PPATH - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on...

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

    1033
    1733     
    3733     
    3739     
    3779
    8779
    8179     
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Example

Input:
3
1033 8179
1373 8017
1033 1033

Output:
6
7
0

hide comments
varuntumbe: 2020-03-28 12:04:42

I was worried about complexity of storing prime in adjacent list (mine takes O(n2)), But It works. Nice problem.

amar_shukla1: 2020-03-20 07:56:10

AC in one go fellas!!

manish_thakur: 2020-02-20 07:31:36

AC in four days!

shahayush457: 2020-02-10 18:58:21

Can there be any impossible case ?? I guess no.

luvkumbi: 2020-02-04 21:12:57

AC in one go !

daddys_home: 2020-01-04 08:11:19

revised prime sieve did it in 0.01 sec using bfs
i guess with floyd warshall could have done it in 0s
AC in one go!!!!

rahulrawat09: 2019-12-04 17:22:43

evolution of comment section
2010: "Nice ques! BFS is the key here"
2019: "AC in one go"

parvezaalam786: 2019-11-23 16:56:04

first find all the 4 digit prime no. , make the adjacency list by adding the numbers if they differ by one digit and then do the bfs for getting the shortest path(minimum cost)

vamsi99: 2019-09-25 11:28:22

AC in one go

adrisos: 2019-08-17 12:25:08

Can someone pleeeeease comment some test cases?
I get SIGSEGV every time i send the code

Last edit: 2019-08-17 13:02:47

Added by:overwise
Date:2007-10-02
Time limit:2s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO NODEJS PERL6 VB.NET
Resource:ACM ICPC NWERC 2006